C
C  Program : REF2CIF
C
C  Transforms REFs to a multiple CIF, 
C              if the REF contains atomic coordinates...
C
C
C   Armel Le Bail (alb@cristal.org) - May 2003
C
C
      program main
      character fname*20,fname1*20,fname2*7,text*1000,text2*80
      character*20 infile,erfile,infile2
      character chemfm*80,chemform*255,chemfor2*255
      character totext*2000,sgname*80
      character*8 ftype(30)
      logical lexist
      dimension rcelln(6),al(3,3),cell(6),fnamtp(30)
C
C
C
      write
     1(*,'('' Enter name of multiple REF (no extension) :'',$)')
      read (*,'(a)')fname1
      if (fname1 .eq. '0') goto 1
      if (fname1 .eq. ' ') goto 1
C ---- now open .ref file
      ilen=leng(fname1)
      infile=fname1(1:ilen)//'.ref'
      open (25,file=infile,status='unknown')
C ---- now open .cif file
      infile2=fname1(1:ilen)//'.cif'
      erfile=fname1(1:ilen)//'.err'
      inquire (file=infile2,exist=lexist)
      if (lexist) then
         write (*,
     1  '('' Target .txt file already exists. Overwrite? Y/N [Y]:'',$)')
         read (*,'(a)')ans
         if (ans .eq. 'N' .or. ans .eq. 'n') go to 1
      endif
      open (27,file=infile2,status='unknown')
      open (26,file=erfile,status='unknown')
C
C
      ifname2=7000000
C
C Loop on the new COD entries from the REF file
C
1     ifname2=ifname2+1
      write(fname2,'(i7)')ifname2
C
C   Write data_
C
      write(27,'(a,a)')'data_new',fname2
C
C   Read total text 
C
      read(25,'(a)',err=300)totext
      if(totext.eq.' ')then
      read(25,'(a)',err=300)totext
      endif
      i10=leng(totext)
      if(i10.eq.0)totext='unknown'
C
C   Write all text into _publ_section_title
C
4000  format(80A1)
      write(27,'(a)')'_publ_section_title'
      write(27,'(a)')';'
      write(27,4000)(totext(i:i),i=1,i10)
      write(27,'(a)')';'
C
C   Read chemical formula
C
      read(25,'(a)')chemfm
      call chform(chemfm,ftype,fnamtp,ntype)
      chemform=' '
      if (ntype .ge. 1) then
         if(ntype.gt.24)ntype=24
         write (*,'('' Chemical formula::''/,24(a2,1x,f6.2,1x))')
     1   (ftype(i),fnamtp(i),i=1,ntype)
         write (26,'('' Chemical formula::''/,24(a2,1x,f6.2,1x))')
     1   (ftype(i),fnamtp(i),i=1,ntype)
      write(chemform,'(a2,24(a2,1x,f6.2,1x))')
     1'- ',(ftype(i),fnamtp(i),i=1,ntype),' -'
      elseif (ntype .eq. -1) then
C ---- error messages
         call prstr(' ')
         call prstr(' :: Blanks must separate element fields,')
         call prstr
     1   (' :: no blanks between element and index, eg P (C H3)3')
      endif
C
C   Write chemical formula sum
C
      i9=leng(chemfm)
      chemfm='_chemical_formula_sum   '//"'"//chemfm(1:i9)//"'"
      i9=leng(chemfm)
      write(27,'(a)')chemfm(1:i9)
C
C   Read cell parameters
C
C
C ---- Now get unit cell information
C
      Read(25,*)(cell(i),i=1,6)
C
C   Write cell parameters
C
      write(27,'(a,f9.4)')'_cell_length_a       ',cell(1)
      write(27,'(a,f9.4)')'_cell_length_b       ',cell(2)
      write(27,'(a,f9.4)')'_cell_length_c       ',cell(3)
      write(27,'(a,f7.3)')'_cell_angle_alpha    ',cell(4)
      write(27,'(a,f7.3)')'_cell_angle_beta     ',cell(5)
      write(27,'(a,f7.3)')'_cell_angle_gamma    ',cell(6)
C
C ---- Now calculate volume
C
      DO 829 I=1,3
      DO 829 J=1,3
829   AL(I,J)=0.0
3050  FORMAT(/' Cell parameters : ',3F9.4,3F10.3/)
      CALL DCELL(CELL,AL,RCELLN,VOLB)
C
C   Write cell volume
C
      write(27,'(a,f12.2)')'_cell_volume     ',volb
C
C   Read space group
C
       read(25,'(a)')sgname
C
C  Write space group
C
      i8=leng(sgname)
      sgname='_symmetry_space_group_name_H-M   '//"'"//sgname(1:i8)//"'"
      i8=leng(sgname)
      write(27,'(a)')sgname(1:i8)
C
C  Write the atomic coordinates stuff
C
      write(27,'(a)')'loop_'
      write(27,'(a)')'_atom_site_label'
      write(27,'(a)')'_atom_site_symmetry_multiplicity'
      write(27,'(a)')'_atom_site_Wyckoff_symbol'
      write(27,'(a)')'_atom_site_fract_x'
      write(27,'(a)')'_atom_site_fract_y'
      write(27,'(a)')'_atom_site_fract_z'
      write(27,'(a)')'_atom_site_occupancy'
      write(27,'(a)')'_atom_site_Uiso_or_Biso'
C
C  Read and write for each line
C
20    read(25,'(a)',err=300) text2
      if (text2.eq.' ')go to 1
      write(27,'(a)')text2
      go to 20
C
C----------------------------------------------------------------------
C
C
C End of loop
C
300   continue
30    close (26)
      close (25)
      close (27)
C
      stop
      end
C
C----------------------------------------------------------------------
C
      integer function leng(string)
C     returns significant length of  'string'
      character*(*)string
      do 1 leng=len(string),0,-1
1        if (string(leng:leng) .ne. ' ') goto 2
2     end
C
C----------------------------------------------------------------------C
C
      subroutine prstr(message)
C ---- prints message
      character*(*)message
      write (6,'(a)')message
      write (26,'(a)')message
      end
C
C----------------------------------------------------------------------C
C
      subroutine trim(string)
C ---- remove leading blanks from 'string' 
      character*(*)string
      integer i,ilen,iblank
      ilen=len(string)
      iblank=0
      do 1 i=1,ilen
         if (string(i:i) .ne. ' ') goto 2
1        if (string(i:i) .eq. ' ')iblank=iblank+1
2     if (iblank .ne. 0) then
         do 3 i=1,ilen-iblank
3           string(i:i)=string(i+iblank:i+iblank)
         string(ilen-iblank+1:ilen)=' '
      endif
      end
C
C----------------------------------------------------------------------
C
      subroutine chform(chemfm,namtyp,fnamtp,natmtp)
C
C===== Conversion of a string record of the chemical formula into the
C     component sums of elements. Adapted from a subroutine by B.Kilger
C===== 07/83 modified by R.Sievers 9.85 and 7.88 and L.J. Farrugia 5.96
C
C    definition of arguments:
C    chemfm:  input string (character*(32)) with the structural
C     formula
C    namtyp:  character*2-array (length: 30) with natmtp found
C     element symbols
C    nelist:  return of element numbers, alphabetical
C    fnamtp:  return of corresponding indices
C    30:      maximum length of arrays namtyp, nelist and fnamtp
C    natmtp:    > 0 - number of found elements
C               < 0 - Error. :  -1 : syntax error
C                               -2 : illegal special symbol
C                               -3 : unrecognised element
C                               -4 : unmatched brackets
C                               -5 : conversion error
C                               -6 : too many different elements
C
      character*80 buf,chemfm
      character*8 namtyp(30)
      character*1 idmxx
      character*1 nb,flank,nc2,nz
      character*2 nel4
      character*2 nele(106)
      logical integ
C
      real f,ftot,fsav
      real fak(20),fnamtp(30)
C
      integer iendfl,ilpar,irpar,idig,iele,idezpt,istp,ipnt
      integer izifer,nv,nh,nr,i,jbeg,jl,ja,nesav,jend,klein
      integer ji,kleinp,j,ibuf
      integer nelist(30)
C
C----Listing order for the elements. The following 6 elements
C    appear in the indicated order, all other elements will
C    appear in alphabetical order : C H O N S P
C
      integer ielord(6)
      data ielord/15,38,65,57,82,67/
C
      data nele/'AC','AG','AL','AM','AR','AS','AT','AU','B ','BA',
C                1    2    3    4    5    6    7    8     9    10
     1 'BE','BI','BK','BR','C ','CA','CD','CE','CF','CL','CM','CO',
C       11   12   13   15    15   16   17   18   19   20   21   22
     1 'CR','CS','CU','D ','DY','ER','ES','EU','F ','FE','FM','FR',
C       23   24   25    26   27    28   29   30    31   32   33   34
     1 'GA','GD','GE','H ','HE','HF','HG','HO','I ','IN','IR',
C       35   36   37    38   39   40   41   42    43   44   45
     1 'K ','KR','KU','LA','LI','LU','LW','MD','MG','MN','MO',
C       46   47   48    49   50   51   52    53   54   55   56
     1 'N ','NA','NB','ND','NE','NI','NO','NP','O ','OS',
C       57   58   59   60   61   62   63   64    65   66
     1 'P ','PA','PB','PD','PM','PO','PR','PT','PU','RA','RB','RE',
C       67   68   69   70   71   72   73   74   75    76   77   78
     1 'RH','RN','RU','S ','SB','SC','SE','SI','SM','SN','SR','T',
C       79   80   81    82   83   84   85   86   87   88   89   90
     1 'TA','TB','TC','TE','TH','TI','TL','TM','U ','V ','W ',
C       91   92   93   94   95   96   97   98    99   100    101
     1 'XE','Y ','YB','ZN','ZR'/
C       102   103  104   105  106
C
      data nb/' '/
      data flank/' '/
      data nel4/' '/
      data nc2/' '/
      data idmxx/' '/
C
      natmtp=0
      f=1.0
      iendfl=0
      ilpar=0
      irpar=0
      idig=0
      iele=0
      idezpt=0
      istp=0
      ipnt=81
      nc2='0'
C
C --- first remove unecessary blanks from string
C
      call trim(chemfm)
      ibuf=0
      buf=' '
      do i=1,80
         if (i .eq. 80 .and. chemfm(i:i) .ne. ' ') then
            ibuf=ibuf+1
            buf(ibuf:ibuf)=chemfm(i:i)
            goto 1
         endif
         if (i .eq. 80) goto 1
         if (chemfm(i:i) .eq. ' ' .and. integ(chemfm(i+1:i+1)))
     1   goto 1
         if (chemfm(i:i) .eq. ' ' .and. chemfm(i+1:i+1) .eq. ' ')
     1   goto 1
         ibuf=ibuf+1
         buf(ibuf:ibuf)=chemfm(i:i)
1        continue
      enddo
      chemfm=buf
C
C
C     ***  read input string from right to left  ***
100   ipnt=ipnt-1
      if (ipnt .lt. 1) goto 7000
      nb(1:1)=chemfm(ipnt:ipnt)
      nz(1:1)=chemfm(ipnt:ipnt)
C
C             A...Z     a...z     0...9   blank  special char.
C    -----------------------------------------------------
C    EBCDIC 193..233  129...169 240..249    64    65..128
C    ASCII   65...90   97...122  48...57    32    33...47
C
C----lower- or uppercase character or integer?
      if (lge(nz,'0')) goto 200
C
C----special character ?
      if (nz .eq. ' ') goto 5000
      if (nz .eq. '(') goto 3000
      if (nz .eq. ')') goto 4000
      if (nz .eq. '.') goto 4500
      goto 9902
C
C---- lower- or uppercase character or integer
C     (uppercase character ...)
200   if (lle(nz,'Z') .and. lge(nz,'A')) goto 2000
      if (lle(nz,'9') .and. lge(nz,'0')) goto 1000
C     (lowercase character ...)
      if (lgt(nz,'z') .or. llt(nz,'a')) goto 9902
C     lower -> upper case conversion
      if (lge(nb,'a') .and. lle(nb,'z')) then
         nb=char(ichar(nb)-ichar('a')+ichar('A'))
      endif
      goto 2000
C
C     ***  integer  ***
1000  if (idig .gt. 0) goto 1100
      if (iele .gt. 0 .or. ilpar .gt. 0) goto 9901
      if (idezpt .le. 0)f=0.0
C
1100  izifer=ichar(nz)-ichar('0')
      f=f+float(izifer)*10.0**(idig-idezpt)
      idig=idig+1
      irpar=0
      goto 100
C
C     ***  character  ***
2000  if (ilpar .gt. 0) goto 9901
      irpar=0
      idig=0
      idezpt=0
      iele=iele+1
      goto (2020,2030,9903),iele
2020  nel4(1:1)=nb
      nel4(2:2)=flank
      goto 100
2030  idmxx=nel4(1:1)
      nel4(2:2)=idmxx
      nel4(1:1)=nb
      goto 100
C
C     ***  left bracket  ***
3000  if (idig .gt. 0 .or. irpar .gt. 0) goto 9901
      ilpar=1
      if (iele .gt. 0) goto 6000
3010  istp=istp-1
      if (istp .lt. 0) goto 9904
      goto 100
C
C     ***  right bracket  ***
4000  if (iele .gt. 0 .or. ilpar .gt. 0) goto 9901
      idig=0
      idezpt=0
      irpar=1
      istp=istp+1
      if (istp .gt. 24) goto 9904
      fak(istp)=f
      f=1.0
      goto 100
C
C     ***  decimal point  ***
4500  if (idezpt .gt. 0) goto 9905
      f=f*10.0**(-idig)
      idig=idig+1
      idezpt=idig
      goto 100
C
C     ***  blank  ***
5000  if (idig .gt. 0) goto 9901
      ilpar=0
      if (iele .lt. 1) goto 100
C
C **********************************************************************
6000  continue
C
      nv=1
      nh=106
      nr=65
      goto 25
10    nv=nr+1
20    if (nv .gt. nh) goto 30
      nr=(nv+nh)/2
25    if (nel4 .eq. nele(nr)) goto 40
      if (lgt(nel4,nele(nr))) goto 10
      nh=nr-1
      goto 20
C
30    nr=0
40    continue
C **********************************************************************
C
      if (nr .le. 0) goto 9903
      ftot=f
      if (istp .le. 0) goto 6050
      do 6020 i=1,istp
6020     ftot=ftot*fak(i)
6050  if (natmtp .le. 0) goto 6100
      do 6070 i=1,natmtp
         if (nr .ne. nelist(i)) goto 6070
         fnamtp(i)=fnamtp(i)+ftot
         goto 6150
6070  continue
6100  natmtp=natmtp+1
      if (natmtp .gt. 30) goto 9906
      fnamtp(natmtp)=ftot
      nelist(natmtp)=nr
6150  f=1.0
      iele=0
      if (ilpar .gt. 0) goto 3010
      if (iendfl .le. 0) goto 100
C
C     ***  end of scan from right to left  ***
7000  iendfl=1
      if (istp .ne. 0) goto 9904
      if (iele .gt. 0) goto 6000
C
C     *** ordering of elements  ***
      if (natmtp .le. 0) goto 9999
      jbeg=1
C
C----The specified elements are placed first.
      do 7030 jl=1,6
C----search for element ielord(jl) in the formula:
         do 7010 ja=jbeg,natmtp
            if (nelist(ja) .eq. ielord(jl)) goto 7020
7010     continue
C---- not in the formula
         goto 7030
C
7020     nesav=nelist(ja)
         nelist(ja)=nelist(jbeg)
         nelist(jbeg)=nesav
         fsav=fnamtp(ja)
         fnamtp(ja)=fnamtp(jbeg)
         fnamtp(jbeg)=fsav
C
         jbeg=jbeg+1
         if (jbeg .eq. natmtp) goto 9000
7030  continue
C
      jend=natmtp-1
      do 7100 ja=jbeg,jend
         klein=999
         do 7060 ji=ja,natmtp
            if (nelist(ji) .ge. klein) goto 7060
            klein=nelist(ji)
            kleinp=ji
7060     continue
         fsav=fnamtp(kleinp)
         fnamtp(kleinp)=fnamtp(ja)
         fnamtp(ja)=fsav
         nesav=nelist(kleinp)
         nelist(kleinp)=nelist(ja)
         nelist(ja)=nesav
7100  continue
C
9000  if (natmtp .gt. 0) then
         do 9020 j=1,natmtp
            namtyp(j)=nele(nelist(j))
C
C           2. convert to lowercase character
            if (namtyp(j)(2:2) .ne. ' ') then
               namtyp(j)(2:2)=char(ichar(namtyp(j)(2:2))-
     1         ichar('A')+ichar('a'))
            endif
9020     continue
      endif
C
      goto 9999
C
C     ***  general syntax error  ***
9901  natmtp=-1
      goto 9999
C     ***  illegal special symbol  ***
9902  natmtp=-2
      goto 9999
C     ***  illegal element symbol  ***
9903  natmtp=-3
      goto 9999
C     ***  brackets not matched  ***
9904  natmtp=-4
      goto 9999
C     ***  convertion error  ***
9905  natmtp=-5
      goto 9999
C     ***  too many elements in formula  ***
9906  natmtp=-6
C
9999  continue
      return
      end
C
C----------------------------------------------------------------------C
C
      logical function integ(char1)
C ----- tests whether char1 is a numeric character
      character char1,number(11)
      data number/'0','1','2','3','4','5','6','7','8','9','.'/
      integ=.false.
      do i=1,11
         if (char1 .eq. number(i))integ=.true.
      enddo
      end
*
*----------------------------------------------------------------------- 
*
      SUBROUTINE TRCL(CELLN,RCELLN,V)
C     TRANSFORMS REAL CELL TO RECIPROCAL OR VICE VERSA 
C     INPUT CELL IS IN ARRAY CELL AS LENGTHS AND COSINES
      DIMENSION CELLN(6),RCELLN(6)
      DIMENSION SINA(3)
      ABC=1.0
      PROD=2.0
      V=-2.0
      DO 10 I=1,3
      L=I+3
      SINA(I)=1.0-CELLN(L)**2
      V=V+SINA(I)
      SINA(I)=SQRT(SINA(I))
      PROD=PROD*CELLN(L)
10    ABC=ABC*CELLN(I)
      V=ABC*SQRT(V+PROD)
C      V IS CELL VOLUME
C     PUT INVERTED CELL INTO RCELL
      DO 20 I=1,3
      CALL PERM(I,J,K)
      RCELLN(I)=CELLN(J)*CELLN(K)*SINA(I)/V
      L=I+3
20    RCELLN(L)=(CELLN(J+3)*CELLN(K+3)-CELLN(L))/(SINA(J)
     2 *SINA(K))
      RETURN
      END
*
*----------------------------------------------------------------------- 
*
      SUBROUTINE DCELL(CELLN,AL,RCELLN,V)
      DIMENSION CELLN(6),AL(3,3),RCELLN(6),CELL(6)
      DEGRAD=3.14159/180.0
      DO 30 I=1,6
30    CELL(I)=CELLN(I)
      DO 31 I=1,3
      L=I+3
      IF(CELL(L)-90.0)32,33,32
33    CELL(L)=0.0
      GOTO 31
32    CELL(L)=COS(DEGRAD*CELL(L))
31    CONTINUE
      CALL TRCL(CELL,RCELLN,V)
C     RCELL IS THE RECIPROCAL CELL CONSTANTS
      DO 34 I=1,3
      AL(I,I)=RCELLN(I)*RCELLN(I)
      CALL PERM(I,J,K)
      IF(J-K)35,36,36
35    AL(J,K)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
      GOTO 34
36    AL(K,J)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3) 
34    CONTINUE
      DO 37 I=4,6
37    RCELLN(I)=ACOS(RCELLN(I))/DEGRAD
      RETURN
      END
*
*----------------------------------------------------------------------- 
*
      SUBROUTINE PERM(I,J,K)
C     PERMS USEFUL COMBINATIONS OF INTEGERS IN THE RANGE 1 TO 3
      IF(I-2)10,20,30
10    J=2
      K=3
      RETURN
20    J=3
      K=1
      RETURN
30    J=1
      K=2
      RETURN
      END
C
C
C
